//import java.util.*;

/**
 * Clase que representa un diccionario de informatica
 */
public class Diccionario
{
    // el diccionario se guarda en un mapa
    //private MapaAbierto<String,String> dicc;
    private MapaCerrado<String,String> dicc;

    /**
     * Constructor que deja el diccionario vacio
     */
    public Diccionario()
    {
        //dicc = new MapaAbierto<String,String>(10);
        dicc = new MapaCerrado<String,String>(10);
    }

    /**
     * Anadir una palabra con su descripcion
     */
    public void anadePalabra(String palabra, String descripcion)
    {
        dicc.put(palabra,descripcion);
    }
    
    /**
     * Consultar una palabra; retorna la descripción,
     * o null si la palabra no existe
     */
    public String consultaPalabra (String palabra) {
        return dicc.get(palabra);
    }
    
    /**
     * Saber si una palabra esta en el diccionario
     */
    public boolean estaDefinida(String palabra) {
        return dicc.containsKey(palabra);
    }
    
    //     /**
    //      * Mostrar la lista de todas las palabras
    //      */
    //     public void mostrarPalabras() {
    //         Set<String> palabras=dicc.keySet();
    //         System.out.println();
    //         System.out.println("Palabras del diccionario:");
    //         for (String s:palabras) {
    //             System.out.println("   "+s);
    //         }
    //     }
    
}
