import java.util.*;

/**
 * Programa de prueba de conjuntos
 */
public class PruebaConjunto
{
    public static void recorre (Set<Integer> conj) 
    {
        // Los metemos en un conjunto ordenado para mostrarlos 
        // en un orden predecible 
        SortedSet<Integer> ordenado=new TreeSet<Integer>(conj); 
        if (conj.isEmpty()) {
            System.out.println("El conjunto esta vacio");
        } else {
            System.out.println("---------------------");
            Iterator<Integer> iter = ordenado.iterator();
            while (iter.hasNext()) {
                Integer num = iter.next();
                System.out.println("Elemento:"+num);
            }
            System.out.println("--------------------");
        }
    }
    
    
    
    public static void main(String args[])
    {

        Set<Integer> conj = new HashSet<Integer>();

        Iterator<Integer> iter= conj.iterator();
        
        System.out.println("Prueba de conjuntos con Iterador");
        System.out.println("Recorre un conjunto vacio con iterador");
        recorre(conj);
        System.out.println("");
        System.out.println("Prueba del iterador");
        System.out.println("Ver si hay siguiente: "+iter.hasNext());
        System.out.println("Siguiente");
        try {
            iter.next();
        }catch (NoSuchElementException e){
            System.out.println(e);
        }
        System.out.println("Borra");
        try {
            iter.remove();
        }catch (IllegalStateException e){
            System.out.println(e);
        }
        System.out.println(""); 
        System.out.println("Anade cinco elementos: 1,2,3,4,5");
        for (int i=0; i<=4; i++) {
            try {
                conj.add(new Integer(i+1));
            }catch (UnsupportedOperationException e) {
                System.out.println("Operacion add no soportada");
                break;
            }
        }
        
        recorre(conj);
       
        System.out.println("");
        System.out.println("Contiene elemento");
        System.out.println("Contiene elemento 1 :"+conj.contains(1));
        System.out.println("Contiene elemento 6 :"+conj.contains(6));
       
        System.out.println("Elimina elemento 3");
        try {
            boolean eliminado = conj.remove(new Integer(3));
            System.out.println("Eliminado elemento 3 :"+ eliminado);
            eliminado = conj.remove(new Integer(6));
            System.out.println("Eliminado elemento 6 :"+ eliminado);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
        
        System.out.println("Elimina elemento 4");
        try {
            boolean eliminado = conj.remove(new Integer(4));
            System.out.println("Eliminado elemento 4 :"+ eliminado);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }

        recorre(conj);
        System.out.println("");
       
        // Prueba del metodo remove del iterador
        Set<Integer> borrados=new HashSet<Integer>();
        System.out.println("Prueba del metodo remove del iterador");
        iter=conj.iterator();
        while (iter.hasNext()) {
            borrados.add(iter.next());
            iter.remove();
        }
        System.out.println("Elementos borrados:");
        recorre(borrados);

        System.out.println("Inserto el elemento 9");
        conj.add(new Integer(9));
        recorre(conj);

        System.out.println("Deja vacio");
        conj.clear();
        System.out.println("Tamano despues de borrar : "+conj.size());
       
        System.out.println("Anade cinco elementos: 1,2,3,4,5");
        for ( int i=0; i<=4; i++) {
            try {
                conj.add(new Integer(i+1));
            }catch (UnsupportedOperationException e) {
                System.out.println("Operacion add no soportada");
                break;
            }   
        }
        
        boolean contenido;
        contenido=conj.contains(new Integer(6));
        System.out.println("Muestra elemento inexistente: "+contenido);
        contenido=conj.contains(new Integer(4));
        System.out.println("Muestra elemento existente: "+contenido);

        try {
            contenido=conj.remove(new Integer(6));
            System.out.println("Borrado elemento inexistente: "+contenido);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
        System.out.println("");

        try {
            contenido=conj.remove(new Integer(3));
            System.out.println("Borrado elemento existente: "+contenido);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
        System.out.println("");

        // Prueba para containsAll, addAll, removeAll, retainAll
       
        Set<Integer> nuevoConjunto = new HashSet<Integer>();
        Set<Integer> nuevoConjunto2 = new HashSet<Integer>();
        nuevoConjunto.add(new Integer(4));
        nuevoConjunto.add(new Integer(5));
        nuevoConjunto2.add(new Integer(33));
        nuevoConjunto2.add(new Integer(4));
        recorre(conj);
        System.out.println("nC1 = [ 4 5 ], nC2 = [33 4]");
       
        System.out.println("Metodo containsAll con nC1");
        try {
            System.out.println(conj.containsAll(nuevoConjunto));
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
       
        System.out.println("Metodo containsAll con nC2");
        try {
            System.out.println(conj.containsAll(nuevoConjunto2));
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
       
        try {
            System.out.println("Metodo addAll con nC1");
            System.out.println(conj.addAll(nuevoConjunto));
            recorre(conj);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }

        try {
            System.out.println("Metodo removeAll con nC1");
            System.out.println(conj.removeAll(nuevoConjunto));
            recorre(conj);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
        
        try {
            System.out.println("Metodo removeAll con nC2");
            System.out.println(conj.removeAll(nuevoConjunto2));
            recorre(conj);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
       
        try {
            System.out.println("Metodo addAll con nC1");
            System.out.println(conj.addAll(nuevoConjunto));
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }
        recorre(conj);
        try {
            System.out.println("Metodo retainAll con nC2");
            System.out.println(conj.retainAll(nuevoConjunto2));
            recorre(conj);
        } catch (UnsupportedOperationException e) {
            System.out.println(e);
        }     
        
    }

}
